<?php
/**
 * Short description for file.
 *
 * Long description for file
 *
 * PHP versions 4 and 5
 *
 * Encoding Behavior :  On CakePHP
 * Copyright 2008-2009, auto encoding behavior. (http://blog.widget-info.net)
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @filesource
 * @copyright     Copyright 2008-2009, blog.widget-info.net
 * @since         FtpComponent on CakePHP v 1.2.0
 * @version       $Revision: 10100 $
 * @modifiedby    $LastChangedBy: blog.widget-info.net $
 * @lastmodified  $Date: 2009-08-23 $
 * @license       MIT License
 */
class EncodingBehavior extends ModelBehavior {
	
	//Encode type in model Find.
	var $encoding_to = 'SJIS';
	
	//Encode type in model Save.
	var $save_encoding_to = 'UTF-8';

	//setup
	function setup(&$model, $config = array()) {
		$this->model = $model;
		$this->setEncoding($config);
    }
	//setEncoding()
	function setEncoding($config = array()){
		$this->encoding_to = (isset($config['to']) && !empty($config['to']))?$config['to']:'SJIS';
		$this->save_encoding_to = (isset($config['save']) && !empty($config['save']))?$config['save']:Configure::read('App.encoding');
	}
	
	//Change encoding by AfterFind
	function __ChangeEncodingsAfterFind(&$results){
		mb_convert_variables($this->encoding_to,$this->save_encoding_to,$results);
		return $results;
	}
	//Change encoding by BeforeSave
	function __ChangeEncodingsBeforeSave(&$results){
		mb_convert_variables($this->save_encoding_to,$this->encoding_to,$results);
		return $results;
	}
	
	//After find time.
	function afterFind(&$model, &$results, $primary){
		return  $this->__ChangeEncodingsAfterFind($results);
	}
	
	//Before save time.
	function beforeSave(&$model){
		$model->data = $this->__ChangeEncodingsBeforeSave($model->data);
	}
}
?>